/*
 A konadi OpenSync 0.22 implementation l*ibrary
 Copyright (C) 2010 Tejas Guruswamy <masterpatricko@gmail.com>
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License along
 with this program; if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 
 */

#ifndef AKONADISYNCWRAPPER_H
#define AKONADISYNCWRAPPER_H

extern "C" {
    #include "opensync/opensync_debug.h"
}

#include <QList>
struct OSyncChange;

enum TypesEnabled {
    ContactsEnabled = 0x01,
    EventsEnabled = 0x02,
    TodoEnabled = 0x04,
    NotesEnabled = 0x08
};

class AkonadiSyncWrapper
{  
    public:
        virtual bool initialize(int enabledtypes) = 0;
        virtual bool updateItem(OSyncChange* chg, bool getData) = 0;
        virtual QList<OSyncChange*> listItems() = 0;
        virtual bool deleteItem(OSyncChange* chg) = 0;
        virtual bool addItem(OSyncChange* chg) = 0;
        virtual bool modifyItem(OSyncChange* chg) = 0;
        virtual ~AkonadiSyncWrapper() {};
};

typedef AkonadiSyncWrapper* (*AkonadiSyncInitFunc)(qint64 c, qint64 e);

//helps with type checking
extern __attribute__ ((format(printf, 3, 4))) void osync_debug(const char *subpart, int level, const char *message, ...) ;   
extern __attribute__ ((format(printf, 2, 3))) void osync_trace(OSyncTraceType type, const char *message, ...);

#endif //AKONADISYNCWRAPPER_H